'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _renderRoute = require('./renderRoute');

var _renderRoute2 = _interopRequireDefault(_renderRoute);

var _utils = require('./../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UniversalRouter = function (_Component) {
  _inherits(UniversalRouter, _Component);

  function UniversalRouter(props) {
    var _this2 = this;

    _classCallCheck(this, UniversalRouter);

    var _this = _possibleConstructorReturn(this, (UniversalRouter.__proto__ || Object.getPrototypeOf(UniversalRouter)).call(this, props));

    _this.getRouteData = function (path) {
      return _this.state[path];
    };

    _this.fetchInitialProps = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
        var pathname = _ref2.pathname;

        var _matchRoute, path, component, cache, data;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _matchRoute = (0, _utils.matchRoute)(_this.props.routes, pathname), path = _matchRoute.path, component = _matchRoute.component;
                cache = Boolean(component.cache);

                //  If state.cacheRoute is applied on the route component
                //  Only fetch the data once!

                if (!(!cache || !_this.state.hasOwnProperty(pathname))) {
                  _context.next = 7;
                  break;
                }

                _context.next = 5;
                return (0, _utils.resolveInitialProps)(component, path, pathname);

              case 5:
                data = _context.sent;

                _this.setState(Object.assign(_this.state, _defineProperty({}, pathname, data)));

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    var serverProps = props.serverProps;

    _this.state = _extends({}, serverProps);
    return _this;
  }

  _createClass(UniversalRouter, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        getRouteData: this.getRouteData
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          location = _props.location,
          history = _props.history;

      this.fetchInitialProps(location);
      history.listen(this.fetchInitialProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var routes = this.props.routes;


      return _react2.default.createElement(
        _reactRouterDom.Switch,
        null,
        routes.map(function (_ref3, index) {
          var path = _ref3.path,
              component = _ref3.component,
              rest = _objectWithoutProperties(_ref3, ['path', 'component']);

          return _react2.default.createElement(_reactRouterDom.Route, _extends({ path: path, component: (0, _renderRoute2.default)(component), key: index }, rest));
        })
      );
    }
  }]);

  return UniversalRouter;
}(_react.Component);

UniversalRouter.contextTypes = { router: _propTypes2.default.any };
UniversalRouter.childContextTypes = { getRouteData: _propTypes2.default.func.isRequired };
exports.default = (0, _reactRouterDom.withRouter)(UniversalRouter);