'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _webpackDevMiddleware = require('webpack-dev-middleware');

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = require('webpack-hot-middleware');

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _messaging = require('./../../tools/messaging');

var _webpack3 = require('./../webpack/webpack.config');

var _webpack4 = _interopRequireDefault(_webpack3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (app, config) {
  var isDevEnvironment = config.isDevEnvironment,
      publicPath = config.publicPath,
      distOutput = config.distOutput,
      devCssBundle = config.devCssBundle;


  try {
    if (!isDevEnvironment) {
      app.use(publicPath, _express2.default.static(_path2.default.join(process.cwd(), distOutput, publicPath)));
    }

    if (isDevEnvironment) {
      //  eslint-disable-next-line
      app.locals.compiler = (0, _webpack2.default)((0, _webpack4.default)(config));

      //  eslint-disable-next-line
      app.locals.hotMiddleware = (0, _webpackHotMiddleware2.default)(app.locals.compiler);

      app.locals.compiler.plugin('done', function () {
        var extractedCSS = _path2.default.join(process.cwd(), distOutput, publicPath, devCssBundle);
        app.locals.compiler.outputFileSystem.readFile(extractedCSS, function (err, data) {
          if (!err) {
            app.locals.hotMiddleware.publish({ type: 'css-update', value: data.toString() });
          }
        });
      });

      app.use(publicPath, (0, _webpackDevMiddleware2.default)(app.locals.compiler));
      app.use(app.locals.hotMiddleware);
    }
  } catch (error) {
    throw new Error((0, _messaging.getMessage)('error', { type: 'static', error: error }));
  }

  return app;
};