'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('require-ensure');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _server = require('react-dom/server');

var _utils = require('./../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function (app, config) {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
      var _app, tmpl, serverProps, Root, routes, _matchRoute, meta, path, component, urlParams, metaData;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _app = app;
              tmpl = app.locals.html;

              //  The props we'll inject into the root component

              serverProps = {};

              //  Grab the things we need from the userConfig

              Root = config.root, routes = config.routes;

              //  Resolve the current route from the supplied
              //  array of SPA routes.

              _matchRoute = (0, _utils.matchRoute)(routes, req.url), meta = _matchRoute.meta, path = _matchRoute.path, component = _matchRoute.component;

              //  TODO handle 404's and broken promises

              if (!path) {
                res.status(404);
              }

              //  Fetch any initialProps to populate route data
              urlParams = (0, _utils.getParamsFromUrl)(path, req.url);
              _context.next = 9;
              return (0, _utils.fetchInitialProps)(component.getInitialProps, urlParams);

            case 9:
              serverProps[req.url] = _context.sent;


              //  Get the contextRoute meta data and
              //  populate the html server-side
              metaData = (0, _utils.getMetaData)(meta, urlParams);

              Object.keys(metaData).forEach(function (key) {
                tmpl = tmpl.replace('{meta.' + key + '}', metaData[key]);
              });

              //  Replaces the <div id="root" /> element
              //  with the server rendered application
              _app.locals.output = tmpl.replace('<div id="root" />', '<div id="root">\n      ' + (0, _utils.getRootString)((0, _server.renderToString)(_react2.default.createElement(
                _reactRouter.StaticRouter,
                { location: req.url, context: {} },
                _react2.default.createElement(Root, serverProps)
              )), serverProps) + '\n    </div>');

              next();

            case 14:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
};