'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routes, url) {
  var foundRoute = routes.filter(function (_ref) {
    var path = _ref.path;

    if (!path) {
      return null;
    }

    //  Check for any exact matches
    if (path === url) {
      return path;
    }

    //  Check for dynamic routes
    //  with the ':' as params
    var urlParts = url.split('/');
    var dynamicPath = path.split('/').map(function (part, index) {
      return part.includes(':') && path.replace(part, urlParts[index]);
    }).filter(Boolean)[0];
    return dynamicPath === url;
  });

  if (foundRoute.length === 0) {
    foundRoute = routes.filter(function (route) {
      return route.path === null;
    });
  }

  return foundRoute.length ? foundRoute[0] : null;
};