'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _defaultConfig = require('./../defaultConfig');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _postcssImport = require('postcss-import');

var _postcssImport2 = _interopRequireDefault(_postcssImport);

var _postcssCssnext = require('postcss-cssnext');

var _postcssCssnext2 = _interopRequireDefault(_postcssCssnext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var _ref$localIdentName = _ref.localIdentName,
      localIdentName = _ref$localIdentName === undefined ? _defaultConfig2.default.localIdentName : _ref$localIdentName;
  return [{
    test: /\.js?$/,
    exclude: /node_modules/,
    loader: 'babel-loader',
    options: {
      babelrc: false,
      presets: ['es2015', 'react', 'stage-0'],
      plugins: ['transform-regenerator']
    }
  }, {
    test: /\.(css|scss)?$/,
    exclude: /node_modules/,
    loader: _extractTextWebpackPlugin2.default.extract([{
      loader: 'css-loader',
      options: {
        context: './',
        modules: true,
        importLoaders: 1,
        localIdentName: localIdentName
      }
    }, {
      loader: 'postcss-loader',
      options: {
        plugins: [(0, _postcssImport2.default)({
          addDependencyTo: _webpack2.default
        }), (0, _postcssCssnext2.default)()]
      }
    }])
  }, {
    test: /\.(png|svg)?$/,
    exclude: /node_modules/,
    use: {
      loader: 'file-loader',
      options: {
        name: '[name].[hash].[ext]',
        outputPath: '/images'
      }
    }
  }];
};