import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { requiresPrefetch } from './../utils';

const renderRoute = component => (
  class HOC extends Component {
    static contextTypes = {
      getRouteData: PropTypes.func.isRequired,
    }

    constructor(props, context) {
      super(props);
      const { pathname } = props.location;
      this.state = {
        async: requiresPrefetch(component),
        data: context.getRouteData(pathname),
      };
    }

    render() {
      const WrappedComponent = component;
      const { async, data } = this.state;

      if (async && !data) {
        return null;
      }
      return (<WrappedComponent data={data} />);
    }
  }
);

export default renderRoute;
