import path from 'path';

export default {
  context: path.resolve(process.cwd(), './src'),
  distOutput: '/public',
  jsPath: 'js',
  cssPath: 'css',
  publicPath: '/assets/',
  indexFile: 'index.html',
  staticAssetsPath: '/public/assets',
  localIdentName: '[name]__[local]--[hash:base64:5]',
  autoPrefixer: ['last 2 versions'],
  devCssBundle: 'styles.bundle.css',
  prodCssBundle: 'styles.[contenthash:8].bundle.css',
  diagnostics: {
    heartbeat: '/diagnostic/heartbeat',
    version: '/diagnostic/version',
  },
  isDevEnvironment: (process.env.NODE_ENV !== 'production'),
};
