import React, { Component } from 'react';

export default WrappedComponent => class HOC extends Component {
  constructor() {
    super();
    const hotStyles = document.createElement('style');
    hotStyles.type = 'text/css';
    document.head.appendChild(hotStyles);
    require('webpack-hot-middleware/client')
      .subscribe((updateEvent) => {
        if (updateEvent.type === 'css-update') {
          hotStyles.textContent = '';
          hotStyles.appendChild(document.createTextNode(updateEvent.value));
        }
      });
  }

  render() {
    return <WrappedComponent {...this.props} />;
  }
};
