//  @flow
import reduce from 'lodash/reduce';

type UrlParams = { [string]: any };
type Meta = { [string]: string };

const getMetaData = (meta: Meta, urlParams: UrlParams): ?Meta => (
  urlParams ? reduce(meta, (acc, metaVal, metaKey) => {
    let metaValStr = metaVal;
    const paramKeys = Object.keys(urlParams);
    const paramValues = Object.values(urlParams);

    paramKeys.forEach((key, i) => {
      metaValStr = metaValStr.replace(`{${key}}`, paramValues[i]);
    });

    acc[metaKey] = metaValStr;
    return acc;
  }, {})
  : meta
);

export default getMetaData;
