import { expect } from 'chai';

import mapRequestToData from './mapRequestToData';

describe('mapRequestToData', () => {
  const tests = [
    {
      path: '/pages/:pageId',
      urlParams: { pageId: 1 },
      data: { foo: 'bar' },
      result: { '/pages/': { 1: { foo: 'bar' } } },
    },
    {
      path: '/',
      urlParams: null,
      data: { foo: 'bar' },
      result: { '/': { foo: 'bar' } },
    },
    {
      path: '/foo',
      urlParams: null,
      data: { foo: 'bar' },
      result: { '/foo': { foo: 'bar' } },
    },
  ];

  tests.forEach(({ path, urlParams, data, result }) => {
    it(`should map ${path} correctly`, () => {
      expect(mapRequestToData(path, urlParams, data)).to.eql(result);
    });
  });
});
