import { expect } from 'chai';

import matchRoute from './matchRoute';

const routes = [
  { path: '/', exact: true },
  { path: '/pages/:pageId' },
  { path: '/foo/bar' },
];

describe('matchRoute', () => {
  const tests = [
    { test: '/', result: routes[0] },
    { test: '/pages/1', result: routes[1] },
    { test: '/pages/123', result: routes[1] },
    { test: '/foo/bar', result: routes[2] },
    { test: '/bar/foo', result: null },
  ];

  tests.forEach(({ test, result }) => {
    it(`should return ${JSON.stringify(result)} for ${test}`, () => {
      expect(matchRoute(routes, test)).to.eql(result);
    });
  });
});
