import getParamsFromUrl from './../getParamsFromUrl/getParamsFromUrl';
import fetchInitialProps from './../fetchInitialProps/fetchInitialProps';

const hasInitialProps = component => (
  component.getInitialProps && typeof component.getInitialProps === 'function'
);

export default (component, path, pathname) => {
  if (hasInitialProps(component)) {
    const urlParams = getParamsFromUrl(path, pathname);
    return fetchInitialProps(component.getInitialProps, urlParams);
  }
  return null;
};
